# > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >
# This is 
""
# Created by: Duarte Fontes
# Email: duartefontes@tecnico.ulisboa.pt
# Last Update: 09.09.2019
# > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >

import os,sys,re,os.path
import Converter

def Addd0(arg):
	auxdot = re.findall(r'(?<![a-zA-Z0-9])(\d+\.?(?<![a-z])\d*)', arg)
	auxdot2=[];
	for i in range(len(auxdot)):
		if auxdot[i] not in auxdot2:
			auxdot2.append(auxdot[i])
	for i in range(len(auxdot2)):
		arg = re.sub(r'(?<![a-zA-Z0-9])'+auxdot2[i]+r'(?![a-zA-Z0-9])',auxdot2[i]+'d0',arg)
	return arg

dataFR='dataFR.m'
if os.path.isfile(dataFR):
	f1 = open(dataFR, 'r');
	conv = open('MyTeXForm-last-output.tex', 'w')
	f2 = f1.read()
	scribendum=Converter.FCtoTEX(Converter.FRtoFC(f2),'express')
	conv.write(scribendum)
	conv.close()

dataFC='dataFC.m'
if os.path.isfile(dataFC):
	f1 = open(dataFC, 'r');
	conv = open('MyTeXForm-last-output.tex', 'w')
	f2 = f1.read()
	scribendum=Converter.FCtoTEX(f2,'express')
	conv.write(scribendum)
	conv.close()


dataLT='dataLT.m'
if os.path.isfile(dataLT):
	faux='Matrixind.m'
	rowaux = [];
	if os.path.isfile(faux):
		f = open(faux, 'r');	allLines = f.read().splitlines();	f.close()
		for l in allLines:
			rowaux.append(l)
		rowaux2=[]
		for i in range(len(rowaux)):
			rowaux2.append(rowaux[i].split(', '))
		matnames=[]
		for i in range(len(rowaux2)):
			matnames.append(rowaux2[i][0])
	f1 = open(dataLT, 'r');
	conv = open('FunctionLT.F', 'w')
	f2 = f1.read()
	scri = open('MainLT.F', 'w')

	for h in range(len(matnames)):
		auxmat = re.findall(r''+matnames[h]+'\[(.*?), (.*?)\]', f2)
		for i in range(len(auxmat)):
			f2=f2.replace(matnames[h]+'[' + auxmat[i][0] + ', ' + auxmat[i][1] + ']',matnames[h]+auxmat[i][0]+auxmat[i][1])	
	
	(scribendum,nmax,myvars)=Converter.FCtoLT(f2)
	nt=53; thestr2='';
	thestr='      complex*16 function MyFunction(' + myvars + ')\n'
	for t in range(0,len(thestr),nt):
		if (len(thestr)-t)>nt:
			thestr2=thestr2+thestr[t:t+nt]+'\n     & '
		else:
			thestr2=thestr2+thestr[t:t+nt]+'\n'
	rol=myvars.split(',')
	conv.write('\n')
	conv.write(thestr2)
	conv.write('      implicit none\n')
	conv.write('      integer i\n')
	for h in range(len(rol)):
		conv.write('      real*8 ' + rol[h] + '\n')
	conv.write('      real*8 Pi\n')
	conv.write('      complex*16 Out(200)\n\n')
	conv.write('#include "looptools.h"\n\n')
	conv.write('      pi=acos(-1.d0)\n')
	conv.write('      MyFunction = 0d0\n')
	conv.write(scribendum)
	conv.write('\n')
	conv.write('      do i=1,' + str(nmax) + '\n')
	conv.write('            MyFunction=MyFunction+Out(i)\n')
	conv.write('      enddo\n\n')
	conv.write('      return\n')
	conv.write('      end\n')
	conv.close()
	scri.write('*-----------------------------------------------------------------------*\n')
	scri.write('* This program was automatically generated by FeynMaster \n')
	scri.write('*-----------------------------------------------------------------------*\n')
	scri.write('      program FCtoLT\n')
	scri.write('      implicit none\n')
	scri.write('      integer i,j,iseed\n')
	scri.write('      real*8 lbd2,mu2    ! For LoopTools\n')
	for h in range(len(rol)):
		scri.write('      real*8 ' + rol[h] + '\n')
	scri.write('      real*8 Pi\n\n')
	scri.write('      complex*16 MyFunction\n\n')
	scri.write('#include "looptools.h"\n')
	scri.write('#include "MyParameters.h"\n\n')
	scri.write('      call ltini\n\n')
	scri.write('      open(50,file=\'LTout.dat\',status=\'unknown\')  \n\n')
	scri.write('      pi=acos(-1.d0)\n')

	fPV='ParamsValues.m'
	ecri = open('MyParameters.h', 'w')
	if os.path.isfile(fPV):
		f = open(fPV, 'r');	allLines = f.read().splitlines();	f.close()
		ecri.write('       Parameter(\n')
		totco=0
		for l in allLines:
			totco+=1
			mysplit1=l.split('=')
			if any(mysplit1[0] == x for x in matnames):
				mysplit2=mysplit1[1].split(',')
				for k in range(len(matnames)):
					if mysplit1[0]==matnames[k]:
						count=0
						for k1 in range(int(rowaux2[k][1])):
							for k2 in range(int(rowaux2[k][2])):
								if totco == len(allLines) and (k1+1) == int(rowaux2[k][1]) and (k2+1) == int(rowaux2[k][2]):
									ecri.write('     &		'+mysplit1[0]+str(k1+1)+str(k2+1)+'='+Addd0(mysplit2[count])+'\n')
								else:
									ecri.write('     &		'+mysplit1[0]+str(k1+1)+str(k2+1)+'='+Addd0(mysplit2[count])+',\n')
								count+=1
			else:
				if totco == len(allLines):
					ecri.write('     &		'+Addd0(l)+'\n')
				else:
					ecri.write('     &		'+Addd0(l)+',\n')
		ecri.write('     &)\n')
	scri.write('\n')
	scri.write('* Write now the rest of the program\n')
	scri.write('\n\n\n\n\n\n')
	scri.write('* Final declarations:\n')
	scri.write('      call ltexi\n\n')
	scri.write(' 98   format(6(e13.5,1x))\n\n')
	scri.write('      end\n')
	scri.close()